;===========================================================================================
; Button_3.asm  Fasm Flat assembler
; Exemple boite de dialogue sans section resource bouton
; Programm par AsmGges France
;===========================================================================================

format PE GUI 4.0
entry start

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  include 'win32a.inc'
  include 'macro\if.inc'

  ID_PUSHBUTTON          = 101
  ID_DEFPUSHBUTTON       = 102
  ID_USERBUTTON          = 103
  ID_CHECKBOX            = 104
  ID_AUTOCHECKBOX        = 105
  ID_RADIOBUTTON         = 106
  ID_AUTORADIOBUTTON     = 107
  ID_3STATE              = 108
  ID_AUTO3STATE          = 109
  ID_GROUPBOX            = 110
  ID_LISTBOX1            = 111
  ID_LISTBOX2            = 112
  ID_COMBOBOX            = 113
  ID_PUSHBUTTON_EDIT     = 201
  ID_PUSHBUTTON_EXIT     = 202
  ID_PUSHBUTTON_COMBOBOX = 203
  ID_EDIT                = 301

  DDL_ARCHIVE   = 020h
  DDL_DRIVES    = 04000h
  DDL_DIRECTORY = 010h

; local data text, for messages or when the speed is not necessary
macro LocalTxt name, text
{   local label
    jmp label
        name db text,0
    label:  }

; cration d'une fonte courante  =>eax=handle font
macro DlgFont hfont, fontname, size, fnWeight, charset, family
{  local label,fname
   jmp label
       fname db fontname,0
   label:
   invoke CreateFont,size,0, 0, 0,  fnWeight, 0, 0, 0, charset, OUT_DEFAULT_PRECIS,\
                     CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,DEFAULT_PITCH+family, fname  }

; BUTTON/EDIT/STATIC/LISTBOX/SCROLLBAR/COMBOBOX class acces  =>eax=handle child button
macro DlgCreate hfont, classname, buttontxt, id, xleft, ytop, xw, yh, buttonstyle
 { local label,name,class,yh2
   jmp label
       if classname eq 'STATIC'
          class db 'STATIC',0
          yh2=yh shl 1
       else
          class db classname,0
          yh2=yh
       end if
       name  db buttontxt,0
   label:
   invoke CreateWindowEx, 0, class, name,WS_VISIBLE+WS_CHILD + buttonstyle,\
                          xleft, ytop, xw, yh2,[@hWnd], id, [wc.hInstance], 0
   push eax
   invoke SendMessage,eax,WM_SETFONT,hfont,NULL
   pop eax }

;===========================================================================================
; Dbut du code programme
; -----------------------
section '.code' code readable executable

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],IDI_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,0,ClassName,Titre,WS_CAPTION+WS_POPUP+WS_SYSMENU+\
                          WS_MINIMIZEBOX,[WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,msg,0,0,0
    or eax,eax
    jz ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,msg

    jmp MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
proc WindowProc uses ebx esi edi, @hWnd, @uMsg, @wParam, @lParam
    local .hFont:DWORD, .hFont2:DWORD, .IndexItem:DWORD

    .if [@uMsg] = WM_CLOSE
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],MsgEnd,ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0

    .elseif [@uMsg] = WM_CREATE
        ; Defines the current font for the text
        DlgFont [.hFont],'MS Sans Serif',8,FW_NORMAL,ANSI_CHARSET,FF_SWISS
        mov [.hFont],eax

        ; Defines on other font for the text
        DlgFont [.hFont],'Verdana',12,FW_BOLD,ANSI_CHARSET,FF_SWISS
        mov [.hFont2],eax

        ; Create: child window GroupBox
        DlgCreate [.hFont],'BUTTON','AsmGges GroupBox',ID_GROUPBOX,5,5,392,362,BS_GROUPBOX

        ; Create: child window PushButton
        DlgCreate [.hFont],'BUTTON','PushButton',ID_PUSHBUTTON,18,26,160,22,BS_PUSHBUTTON

        ; Create: child window DefPushButton
        DlgCreate [.hFont],'BUTTON','DefPushButton',\
                  ID_DEFPUSHBUTTON,18,56,160,22,BS_DEFPUSHBUTTON

        ; Create: child window UserButton
        DlgCreate [.hFont],'BUTTON','UserButton',ID_USERBUTTON,18,86,160,22,BS_USERBUTTON

        ; Create: child window CheckBox
        DlgCreate [.hFont],'BUTTON','CheckBox',ID_CHECKBOX,18,116,100,24,BS_CHECKBOX

        ; Create: child window AutoCheckBox
        DlgCreate [.hFont],'BUTTON','AutoCheckBox',\
                  ID_AUTOCHECKBOX,18,144,120,24,BS_AUTOCHECKBOX

        ; Create: child window RadioButton
        DlgCreate [.hFont],'BUTTON','RadioButton',\
                  ID_RADIOBUTTON,18,172,110,24,BS_RADIOBUTTON

        ; Create: child window AutoRadioButton
        DlgCreate [.hFont],'BUTTON','AutoRadioButton',\
                  ID_AUTORADIOBUTTON,18,200,134,24,BS_AUTORADIOBUTTON

        ; Create: child window ThreeState
        DlgCreate [.hFont],'BUTTON','3State',ID_3STATE,18,228,72,24,BS_3STATE

        ; Create: child window Auto3State
        DlgCreate [.hFont],'BUTTON','Auto3State',ID_AUTO3STATE,18,256,101,24,BS_AUTO3STATE
        ;======================================
        ; Create: child window Combobox title
        DlgCreate [.hFont],'STATIC','ComboBox',-1,18,286,140,8,NULL

        ; Create: child window ComboBox
        DlgCreate [.hFont],'COMBOBOX','',ID_COMBOBOX,18,302,120,80,CBS_DROPDOWNLIST+CBS_SORT
        mov [hCbb],eax

        LocalTxt CbbItem1,'Sky is blue,'
        invoke SendMessage,[hCbb],CB_ADDSTRING,0,CbbItem1
        LocalTxt CbbItem2,'sun shines,'
        invoke SendMessage,[hCbb],CB_ADDSTRING,0,CbbItem2
        LocalTxt CbbItem3,'girls are beautiful,'
        invoke SendMessage,[hCbb],CB_ADDSTRING,0,CbbItem3
        LocalTxt CbbItem4,"but I'm in good company,"
        invoke SendMessage,[hCbb],CB_ADDSTRING,0,CbbItem4
        LocalTxt CbbItem5,'with FASM yeah !!'
        invoke SendMessage,[hCbb],CB_ADDSTRING,0,CbbItem5

        ; Create: child window PushButton
        DlgCreate [.hFont],'BUTTON','See Combo text',\
                  ID_PUSHBUTTON_COMBOBOX,18,330,120,22,BS_PUSHBUTTON

        ;======================================
        ; Create: child window text edit title
        DlgCreate [.hFont],'STATIC','Write your text:',-1,220,26,140,8,NULL

        ; Create: child window text edit
        DlgCreate [.hFont],'EDIT','Edit',ID_EDIT,220,42,160,98,\
                         WS_BORDER+\         ;avec bords
                         WS_TABSTOP+\        ;met le clavier dans la fenetre d'dition
                         WS_HSCROLL+\        ;barre de scroll horizontal
                         WS_VSCROLL+\        ;barre de scroll vertical
                         ES_WANTRETURN+\     ;passage  la ligne
                         ES_MULTILINE        ;dition multiligne

        ; Create: child window PushButtonEdit
        DlgCreate [.hFont],'BUTTON','See edited text',\
                  ID_PUSHBUTTON_EDIT,241,144,110,22,BS_PUSHBUTTON

        ; Create: child window ListBox FileDir title
        DlgCreate [.hFont],'STATIC','ListBox: FileDir',-1,220,176,160,8,NULL

        ; Create: child window ListBox FileDir
        DlgCreate [.hFont],'LISTBOX','',ID_LISTBOX1,220,192,160,56,\
                  WS_VSCROLL+WS_BORDER+LBS_HASSTRINGS+LBS_NOINTEGRALHEIGHT+\
                  LBS_DISABLENOSCROLL
        mov [hList1],eax

        LocalTxt FileDir,'*.*'
        invoke SendMessage,[hList1],LB_DIR,DDL_ARCHIVE+DDL_DRIVES+DDL_DIRECTORY,FileDir
        invoke SetWindowLong,[hList1],GWL_WNDPROC,ListBoxProc
        mov [lpLstBox],eax

        ; Create: child window ListBox My list title
        DlgCreate [.hFont],'STATIC','ListBox: My list in bold',-1,220,256,160,8,NULL

        ; Create: child window ListBox My list
        DlgCreate [.hFont2],'LISTBOX','',ID_LISTBOX2,220,272,160,56,\
                            WS_VSCROLL+WS_BORDER+LBS_HASSTRINGS+LBS_NOINTEGRALHEIGHT+\
                            LBS_DISABLENOSCROLL
        mov [hList2],eax

        invoke SetWindowLong,[hList2],GWL_WNDPROC,ListBoxProc
        mov [lpLstBox],eax

        ; My List2
        LocalTxt ListItem1,'Sky is blue,'
        invoke SendMessage,[hList2],LB_ADDSTRING,0,ListItem1
        LocalTxt ListItem2,'sun shines,'
        invoke SendMessage,[hList2],LB_ADDSTRING,0,ListItem2
        LocalTxt ListItem3,'girls are beautiful,'
        invoke SendMessage,[hList2],LB_ADDSTRING,0,ListItem3
        LocalTxt ListItem4,"but I'm in good company,"
        invoke SendMessage,[hList2],LB_ADDSTRING,0,ListItem4
        LocalTxt ListItem5,'with FASM yeah !!'
        invoke SendMessage,[hList2],LB_ADDSTRING,0,ListItem5

        ;------------------------------------
        ; Create: child window PushButtonExit
        DlgCreate [.hFont],'BUTTON','Exit Dialog',\
                  ID_PUSHBUTTON_EXIT,159,340,90,22,BS_PUSHBUTTON

    .elseif [@uMsg] = WM_COMMAND
        ; Mouse click identification and button concerned
        .if [@wParam] = BN_CLICKED shl 16+ID_PUSHBUTTON
            LocalTxt PushButton,'PushButton'
            invoke MessageBox,[@hWnd],PushButton,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_DEFPUSHBUTTON
            LocalTxt DefPushButton,'DefPushButton'
            invoke MessageBox,[@hWnd],DefPushButton,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_USERBUTTON
            LocalTxt UserButton,'UserButton'
            invoke MessageBox,[@hWnd],UserButton,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_CHECKBOX
            LocalTxt CheckBox,'CheckBox'
            invoke MessageBox,[@hWnd],CheckBox,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_AUTOCHECKBOX
            LocalTxt AutoCheckBox,'AutoCheckBox'
            invoke MessageBox,[@hWnd],AutoCheckBox,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_RADIOBUTTON
            LocalTxt RadioButton,'RadioButton'
            invoke MessageBox,[@hWnd],RadioButton,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_AUTORADIOBUTTON
            LocalTxt AutoRadioButton,'AutoRadioButton'
            invoke MessageBox,[@hWnd],AutoRadioButton,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_3STATE
            LocalTxt ThreeState,'3State'
            invoke MessageBox,[@hWnd],ThreeState,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_AUTO3STATE
            LocalTxt Auto3State,'Auto3State'
            invoke MessageBox,[@hWnd],Auto3State,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_PUSHBUTTON_COMBOBOX
            ; In Buffer, text associated to a COMBOBOX control
            invoke GetDlgItemText,[@hWnd],ID_COMBOBOX,Buffer,256
            invoke MessageBox,[@hWnd],Buffer,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_PUSHBUTTON_EDIT
            ; In Buffer, text associated to a EDIT control
            invoke GetDlgItemText,[@hWnd],ID_EDIT,Buffer,256
            ; Text edited
            invoke MessageBox,[@hWnd],Buffer,ClassName,MB_OK+MB_ICONINFORMATION

        .elseif [@wParam] = BN_CLICKED shl 16+ID_PUSHBUTTON_EXIT
            invoke PostQuitMessage,0

        .endif

    .else
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret
    .endif

    mov eax,0
    ret
endp

;===========================================================================================
proc ListBoxProc @hCtl, @uMsg, @wParam, @lParam
    local .IndexItem:DWORD, .Buffer[32]:BYTE

    cmp [@uMsg],WM_LBUTTONDBLCLK
    je  .AffOk
    cmp [@uMsg],WM_CHAR
    jne .AffNo
    cmp [@wParam],13
    jne .AffNo

 .AffOk:
    invoke SendMessage,[@hCtl],LB_GETCURSEL,0,0
    mov [.IndexItem],eax
    lea ebx,[.Buffer]
    invoke SendMessage,[@hCtl],LB_GETTEXT,[.IndexItem],ebx
    invoke MessageBox,[hWnd],ebx,ClassName,MB_OK+MB_ICONINFORMATION

 .AffNo:
    invoke CallWindowProc,[lpLstBox],[@hCtl],[@uMsg],[@wParam],[@lParam]

    ret
endp

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
section '.data' data readable writeable

  Titre     db ' AsmGges boite de dialogue',0
  ClassName db ' AsmGges Win32',0
  MsgEnd    db ' AsmGges France @2006  ',0
  align 4

  WinX      dd 0
  WinY      dd 0
  WinW      dd 408
  WinH      dd 400

  Buffer    rb 500

  hWnd      dd ?
  hList1    dd ?
  hList2    dd ?
  lpLstBox  dd ?
  hCbb      dd ?
  hwnd_cb   dd ?
  wc        WNDCLASS   0, WindowProc, 0, 0, 0, 0, 0, COLOR_BTNFACE+1, 0, ClassName
  msg       MSG
  pt        POINT

;===========================================================================================
; Inclusion des fichiers .dll contenant les fonctions Windows utilises
;-------------------------------------------------------------------------------------------
section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
            user32,'USER32.DLL',\
             gdi32,'GDI32.DLL'

  ; Apis Windows dans fichiers dlls
  ; -------------------------------
  include 'apia\kernel32.inc'
  include 'apia\user32.inc'
  include 'apia\gdi32.inc'

;===========================================================================================
; Inclusion des icnes / curseurs / bitmap
;-------------------------------------------------------------------------------------------
section '.rsrc' resource data readable

  directory RT_ICON,icons,\
            RT_GROUP_ICON,group_icons

  IDI_FRANCE = 17

  resource icons,\
           1,LANG_NEUTRAL,icon_data

  resource group_icons,\
           IDI_FRANCE,LANG_NEUTRAL,main_icon

  icon main_icon,icon_data,'res\france.ico'

;===========================================================================================